TryCatchFinally (JSP 3.1 API Documentation - Apache Tomcat 10.1.48)
Description: declaration: package: jakarta.servlet.jsp.tagext, interface: TryCatchFinally

# Interface TryCatchFinally

public interface TryCatchFinally
The auxiliary interface of a Tag, IterationTag or BodyTag tag handler that wants additional hooks for managing resources.

This interface provides two new methods: doCatch(Throwable) and doFinally(). The prototypical invocation is as follows:

    h = get a Tag();  // get a tag handler, perhaps from pool

    h.setPageContext(pc);  // initialize as desired
    h.setParent(null);
    h.setFoo("foo");

    // tag invocation protocol; see Tag.java
    try {
      doStartTag()...
      ....
      doEndTag()...
    } catch (Throwable t) {
      // react to exceptional condition
      h.doCatch(t);
    } finally {
      // restore data invariants and release per-invocation resources
      h.doFinally();
    }

    ... other invocations perhaps with some new setters
    ...
    h.release();  // release long-term resources

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `doCatch(Throwable t)`
  Invoked if a Throwable occurs while evaluating the BODY inside a tag or in any of the following methods: Tag.doStartTag(), Tag.doEndTag(), IterationTag.doAfterBody() and BodyTag.doInitBody().
  `void`
  `doFinally()`
  Invoked in all cases after doEndTag() for any class implementing Tag, IterationTag or BodyTag.

- ## Method Details

  - ### doCatch

    void doCatch(Throwable t) throws Throwable
    Invoked if a Throwable occurs while evaluating the BODY inside a tag or in any of the following methods: Tag.doStartTag(), Tag.doEndTag(), IterationTag.doAfterBody() and BodyTag.doInitBody().

    This method is not invoked if the Throwable occurs during one of the setter methods.

    This method may throw an exception (the same or a new one) that will be propagated further up the nest chain. If an exception is thrown, doFinally() will be invoked.

    This method is intended to be used to respond to an exceptional condition.

    Parameters:
      `t` - The throwable exception navigating through this tag.
    Throws:
      `Throwable` - if the exception is to be rethrown further up the nest chain.

  - ### doFinally

    void doFinally()
    Invoked in all cases after doEndTag() for any class implementing Tag, IterationTag or BodyTag. This method is invoked even if an exception has occurred in the BODY of the tag, or in any of the following methods: Tag.doStartTag(), Tag.doEndTag(), IterationTag.doAfterBody() and BodyTag.doInitBody().

    This method is not invoked if the Throwable occurs during one of the setter methods.

    This method should not throw an Exception.

    This method is intended to maintain per-invocation data integrity and resource management actions.